#ifndef __XTEXT_
#define __XTEXT_ 
#include <X11/Intrinsic.h>
#include <X11/keysym.h>
#if HAVE_LIBXFT
#include <X11/Xft/Xft.h>
#include <X11/extensions/Xrender.h>
#endif
#define X_CANCEL	"(Ĥ [q])"
#define X_QUIT		"(XJP  λ )"
#define T_NAME		"-- [] [] [Enter]¹ --"
#define S_NAME0		"ڥꥹȴñ(ñ)"
#define S_NAME1 	""
#define S_NAME2 	"RAST(query)"
#define S_NAME3 	""
#define XJP_OK  	"xjp-ok"
#define XJP_CANCEL  	"xjp-cancel"
#define XJP_NOOP	"xjp-noop"
#define STEP_MAX 	8
#include <iconv.h>
#ifdef XJP_ICONV
	iconv_t XJP_CONV = NULL;
#else
	extern iconv_t XJP_CONV;
#endif
enum {
	XJP_NONE = -1,
	XJP_INT,
	XJP_CHA,
	XJP_STR,
	XJP_COL,
	XJP_FONT,
	XJP_ONF
};
enum {
	XJP_LEFT = -1,
	XJP_CENTER,
	XJP_RIGHT
};
typedef struct OTHERFILEPROG{
	char *name,*exec,*data;
	struct OTHERFILEPROG *next;
	struct OTHERFILEPROG *prev;
}other_prog_t;
typedef struct{
	int main_window_width,main_window_height;
	char *main_window_img,*main_window_color,*main_font_color;
	char *main_shadow_color,*find_font_color,*rubi_font_color;
	char *menu_window_color,*menu_font_color;
	char *select_window_color,*select_font_color,*select_font_background_color;
	char *main_font_j,*main_font_s,*main_font_e;
	char *book_dir,*rubi_font,*rast_db;
	char *ao_url, *ao_list;
	char page_next[8],page_prev[8],conf_page[8],book_mark[8];
	char siori_menu[8],quit[8],menu[8];
	char title_key[8],kinsc_key[8],chuki_key[8],page_key[8];
	char net_key[8],cursor_key[8],other_key[8],find_key[8];
	char find_next[8],find_prev[8],rast_key[8];
	int anti,title_on,ruby_on,page_on,kinsc,cursor,chuki;
	int line_space,row_space,max_line;
	other_prog_t *other_head,*other_tail;
}xtext_conf_t;
typedef struct{
	int (*func)(); xtext_conf_t *xconf;
}xtext_func_t;
typedef struct{
	char *book_dir, *ao_url, *ao_list;
}xtext_net_t;
typedef struct{
	Window win,mwin;
	/*Window cwin;*/
	int width,height;
	struct {
		Pixmap img;
		int width,height;
		char *position;
	}image;
	GC gc,bgc,sgc;
	GC fgc,rfgc;
	GC rubi_gc,find_gc;
	XFontSet fs,fs_s,fs_e,rubi_fs;
	long fg_pixel,bg_pixel;
	long menu_fg_pixel,menu_bg_pixel;
	long rubi_fg_pixel,rubi_bg_pixel;
#if HAVE_LIBXFT
	XftFont	*font,*font_s,*font_e,*font_rubi;
	XftDraw	*draw;
	XftColor fg_color,bg_color;
	XftColor rubi_color,find_color;
	XftColor menu_fg_color,menu_bg_color;
#endif
	Visual	*visual;
	Colormap cmap;
	int kinsc,anti,title_on,page_on,cursor,change_font;
}my_window_t;
typedef struct {
	Window parent_win,win;
	int x,y,width,height;
	GC gc,bgc,fgc,rfgc,sgc;
	long fg_pixel,bg_pixel;
	XFontSet fs,fs_s;
#if HAVE_LIBXFT
	XftFont	*font,*font_s;
	XftDraw	*draw;
	XftColor menu_fg_color,menu_bg_color;
#endif
	Visual	*visual;
	Colormap cmap;
	int anti;
}my_subwindow_t;
typedef struct CHARIMAGE{
	unsigned char c1,c2;
	short flag;
	XImage *char_image;
	struct CHARIMAGE *next,*prev;
}image_data_t;
typedef struct PAGEDATA{
	int char_no,page_no;
	struct PAGEDATA *next,*prev;
}page_data_t;
typedef struct {
	char *book,*book_path,*book_title,*book_title_utf8;
	int total_page;
}book_data_t;
typedef struct DRAWDATA{
	int char_header,char_footer;
	int one_line,start_line,end_line;
	int start_low,end_low;
}draw_data_t;
typedef struct CHUDATA{
        char message[256];
        struct CHUDATA *next,*prev;
}chu_data_t;
typedef struct {
	int charSize,charSize_s,charSize_e,charSize_r;
	int m_off,s_off,e_off;
	int xpad,ypad;
	int xpos,ypos;
	draw_data_t *draw;
	book_data_t *book;
	page_data_t *head,*tail;
	page_data_t *find_head,*find_tail;
	image_data_t *im_head,*im_tail;
}char_data_t;
typedef struct SUBWINDOWDATA{
	char *line_str,*re_str;
	void *line_data,*line_data1;
	int (*func)();
	void *func_data0;
	int func_data1;
	int type,line_no,mstr,mdata;
	struct SUBWINDOWDATA *head,*tail;
	struct SUBWINDOWDATA *next,*prev;
}sub_window_t;
typedef struct CTRLWINDOWDATA{
	char *name;
	int xpos0,xpos1,ypos0,ypos1;
	int (*func)();
	void *func_data0;
	struct CTRLWINDOWDATA *next,*prev;
}ctl_window_t;
typedef struct XOFFSET {
        unsigned int c1,c2;
        char font[128];
        int anti,x_off,y_off;
        struct XOFFSET *next,*prev;
}offset_data_t;
typedef struct XJP_FONT_DATA {
        char name[100];
        struct XJP_FONT_DATA *head,*tail;
        struct XJP_FONT_DATA *next,*prev;
}xtext_font_t;
typedef struct XJP_EFONT_DATA{
        char name[50];
        struct XJP_EFONT_DATA *next,*prev;
}xtext_efont_t;
int xtext_Init_Text(Display *,my_window_t *,ICONTENT_T *,char_data_t *);
int xtext_Draw_Text(Display *,my_window_t *,ICONTENT_T *,char_data_t *,page_data_t *);
int xtext_Draw_Text_v(Display *,my_window_t *,unsigned char *[],int ,int ,int);
page_data_t * xtext_Init_Book(Display *,my_window_t *,ICONTENT_T *,char_data_t *,offset_data_t *,xtext_conf_t *,char *,int);
page_data_t * xtext_Redraw_Text(Display *,my_window_t *,ICONTENT_T *,char_data_t *,int);
char *xtextSubWindow(Display *,my_window_t *,sub_window_t *,sub_window_t *,int,int);
char *xtextInputWindow(Display *,my_window_t *,char *,char *,int);
int xtextSubWindow_Message(Display *,my_window_t *,char *);
int xtext_check_image_data(ITEXT_T *);
int xtext_next_kuten(ITEXT_T *,char_data_t *,int);
int xtext_prev_kuten(ITEXT_T *,char_data_t *,int);
int xtext_get_low_space(ITEXT_T *,char_data_t *);
int xtext_get_low_pos(ITEXT_T *,char_data_t *,int);
int xtextBookData2Sub(sub_window_t **,sub_window_t **,IBOOK_T *,int);
int xtextSioriData2Sub(sub_window_t **,sub_window_t **,ISIORI_T *);
int xtextClearChuMessage(Display *,my_window_t *);
int xtextDrawChuMessage(Display *,my_window_t *,char_data_t *);
int xtextChuMessage(Display *,my_window_t *,char_data_t *,char *);
int xtextCursorType(Display *,my_window_t *,char *);
void xtext_usage(char *,double,int);
int menu_win(void *,int);
int config_win(void *,int);
int select_book_data(void *,int);
int select_siori_data(void *,int);
int select_person_data(void *,int);
int select_serch_data(void *,int);
int select_conf_key(void *,int);
sub_window_t * _subwindow_data_alloc();
void * subwindow_data_free(sub_window_t **,sub_window_t **);
void * subwindow_data_add(sub_window_t **,sub_window_t **,sub_window_t *);
int xtext_get_string_size(Display *,my_window_t *,char *,char *,int *,int *,int);
int xtextDrawPageTitleString(Display *,my_window_t *,char *,char *,int ,int ,int);
int xtextCheckFindData(ICONTENT_T *,char_data_t *,char *);
int page_data_insert(page_data_t **,page_data_t **,int,int);
void page_data_free(page_data_t **,page_data_t **);
/*
void * _subwindow_data_insert(sub_window_t **,sub_window_t **,char *,char *,char *,int,void *,int ,int ,int );
*/
int xtext_Draw_Help(Display *,my_window_t *,xtext_conf_t *);
int xtextHelpData2Sub(sub_window_t **,sub_window_t **,xtext_conf_t *);
char * xtext_conf_data(xtext_conf_t *);
int xtext_conf_change(void *,int);
int xtext_conf_quit(void *,int);
int xtext_conf_save(void *,int);
void SetOffset(char *,int,int);
void GetOffset(char,int *,int *);
void euc2utf8_c(iconv_t,char *,char *,int);
char *euc2utf8(iconv_t,char *,int);
unsigned int xstring2uint(char *);
int checkStepNumber(char *,char[],int);
int xtext_offt_data(offset_data_t **,offset_data_t **);
int xtext_set_offset(IBUF_T *,IBUF_T *,offset_data_t *);
int xtext_offt_set(	offset_data_t *,
			offset_data_t *,
			xtext_conf_t *,
			offset_data_t **,
			offset_data_t **		);

char *xtext_Selector_Window(char *,int);
int xtext_font_J2E(char *,char *);
int parse_xlfd_No(char *,char *,int);
int xtext_xlfd_create(xtext_font_t **,xtext_font_t **,char *);
int xtext_xlfd_getenco(xtext_efont_t **,xtext_efont_t **,char *);
int xtext_xlfd_free(xtext_font_t *);
int xtext_xlfd_free_e(xtext_efont_t *);
void xtext_image_data_free(image_data_t **,image_data_t **);
void char_data_free(char_data_t *);
#endif
